var urls = new Array("appinter/travelregionjsonp/selectTravelRegion.do?callback=?", "appinter/scenicfeaturejsonp/listFeature.do?callback=?");
$(function() {
    sd.ui.initFooter(5, 2);
    sd.dialog.initDialog();
    tourist.showMessageCount();
    initHandlebarHelper();
    initRefreshLayout();
    initHomeTop();
    $(".single_img_box").live("singleTap", function() {
        sessionStorage.setItem("character_id", $(this).attr("id"));
        window.location.href = "characteristics/characteristics.html";
    });
    
    $("#btn-search").on("singleTap",function(){
        window.location.href = "../spot/spot_list_search.html";
    });
});

function initRefreshLayout() {
    var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height() - $('.ui-toolbar-footer').height();
    var refreshDom = $('.ui-refresh').css("width", "100%").css("height", wrapperHeight);
    refreshDom.refresh({
        iScrollOpts : {
            bounce : false
        }
    });
    $(refreshDom).css("height", "auto");
    $(refreshDom).css("overflow", "hidden");
}

function refreshRefreshLayout() {
    $('.ui-refresh').refresh('this')._options.iScroll.refresh();
}

function initHandlebarHelper() {
    // 注册一个生成图片src用的Helper
    Handlebars.registerHelper("genAttachImgSrc", function(value) {
        return tourist.genAttachImgUrl(value);
    });

    Handlebars.registerHelper("genSliderImage", function(vo) {
        var html = "";
        for (var i = 0; i < vo.img.length; i++) {
            html += "<div>";
            if (i < vo.imgurl.length)
                html += '<img lazyload="' + tourist.genAttachImgUrl(vo.img[i]) + '"  class="top_img" onerror="errorRefresh(2)"  imgUrl = "' + vo.imgurl[i] + '"/>';
            else
                html += '<img lazyload="' + tourist.genAttachImgUrl(vo.img[i]) + '"  class="top_img" />';
            html += "</div>";
        }
        return html;
    });
}

/*
 * 加载主页数据
 */
var top_html = "";
function initHomeTop() {
    $.ajaxJSONP({
        type : "GET",
        url : baseUrl + urls[0],
        beforeSend : function() {
            //sd.loading.show();
        },
        success : function(data) {
            if (data.vo)
                $(".ui-toolbar-header-middle-box").html(data.vo.title);
            var regeionInfo = {
                regionId : data.vo.regionId,
                regionName : data.vo.regionName,
                title : data.vo.title
            };
            sessionStorage.setItem("regionInfo", JSON.stringify(regeionInfo));
            var top_source = $("#home-top-template").html();
            var top_template = Handlebars.compile(top_source);
            top_html = top_template(data);
            initHomeBottom();
        },
        error : function(e) {
        	sd.dialog.showShort("加载数据失败，请检查网络连接是否正常！");
            sd.loading.hide();
        },
        complete : function() {
            sd.loading.hide();
        }
    });
}

function initHomeBottom() {

    var regionInfo = JSON.parse(sessionStorage.getItem("regionInfo"));

    $.ajaxJSONP({
        url : baseUrl + urls[1] + "&regionId=" + regionInfo.regionId,
        beforeSend : function() {
        },
        success : function(data) {
            var bottom_source = $("#home-bottom-template").html();
            var bottom_template = Handlebars.compile(bottom_source);
            var bottom_html = bottom_template(data);
            $(".ui-refresh").append(top_html);
            $(".ui-refresh").append(bottom_html);
        },
        error : function(e) {
        	$(".ui-refresh").append(top_html);
            sd.loading.hide();
        },
        complete : function() {
            refreshRefreshLayout();
            
            $(".spot_button").live("singleTap", function() {
                window.location.href = "../spot/spot_list.html";
            });
            $("#slider").slider({
                loop : true,
                viewNum : 1,
                arrow : false,
                imgZoom : false
            });
            $("#slider").find(".top_img").each(function(){
                $(this).on("singleTap",function(){
                    if($(this).attr("imgurl"))
                    	//window.open($(this).attr("imgurl"), '_blank', 'location=yes');
                        window.location.href = $(this).attr("imgurl"); 
                });
            });
            
            sd.loading.hide();
        }
    });
}

//如果因为网络或图片的原因发生异常，则显示该图片
var errorRefresh = function(v) {
    $("#upload_quiz_img").attr("src", "../img/nanjing.png");
};
