/*require.config({
	baseUrl : '.',
	paths: {
		zepto : 'themes/sdui-gmu/gmu/integrated/js/zepto',
		gmu : 'themes/sdui-gmu/gmu/integrated/js/gmu',
		sdapp : 'themes/sdui-gmu/default/js/sdapp',
		common : 'web/js/common'
	}
});


require(['zepto','gmu','sdapp','common'],function(){
    w = $(window).width();
    h = $(window).height();
    initCss(w, h);
    gradualLoad();
	changeOpacity();
    initCss(w, h);
    //getUnreadMessage(); 
});*/

$(function(){
	w = $(window).width() > $(document.body).width() ? $(window).width() : $(document.body).width();
    h = $(window).height() > $(document.body).width() ? $(window).height() : $(document.body).height();
    initCss(w, h);
    gradualLoad();
	changeOpacity();
    initCss(w, h);
    getUnreadMessage(); 
});


var w, h;
var id;
var DELAY_MILLS = 3000;
var opacity = 0;
var frequency = 40;

/**
 * 按屏幕分辨率初始化页面元素的高宽
 * @param {Object} w
 * @param {Object} h
 */
function initCss(w, h){
    $(".bg-img").css("width", $(window).width() + "px");
	$(".bg-img").css("height", $(window).height() + "px");
	$(".content-img").css("width", $(window).width() * 0.6 + "px");
	$(".content-img").css("height", $(window).width() * 0.6 + "px");
}

/**
 * 渐变式的载入
 */
function gradualLoad(){
    id = setInterval("changeOpacity()", DELAY_MILLS / frequency);
}

/**
 * 动态改变透明度
 */
function changeOpacity(){
    opacity += 1 / frequency * 2;
    $(".main").css("opacity", opacity);
    if (opacity >= 2) {
        clearInterval(id);
        gradualComplete();
    }
}

/**
 * 渐变效果完成
 */
function gradualComplete(){  //return; 隐藏
    if (window.localStorage.getItem("isFirst") == null) {
    	window.location.href = "web/guide.html";
    }
    else {
        //loginCheck();
        window.location.href="web/home/home.html";
    }
    
}

function loginCheck(){
	if(tourist.isLogin()) {
		//sd.native.push.pushLogin(dragontang.appuser.userName,dragontang.appuser.userName);
		window.location.href="web/home/home.html";
	} else {
		window.location.href="web/login/login.html";
	}
}

function getUnreadMessage(){
	var url = baseUrl + "appinter/messagejsonp/listMessage.do?callback=?";
	$.ajaxJSONP({
		type : "GET",
		url : url,
		beforeSend : function() {
		},
		success : function(data) {
			if(data&&data.result==1){
				var message = localStorage.getItem("messagelist");
				var messageCount = 0;
				if(message!=null&data.vo!=null){
					var messagelist = JSON.parse(message);
					var list = messagelist.vo;
					for(var i=0;i<data.vo.length;i++){
						(data.vo)[i].isRead = true;
						for(var j=0;j<list.length;j++){
							if((data.vo)[i].messageId==list[j].messageId){
								(data.vo)[i].isRead = list[j].isRead;
								break;
							}
						}
						if((data.vo)[i].isRead){
							messageCount++;
						}
					}
				}else{
					if(data.vo==null){
						localStorage.setItem("messagelist",null);
						localStorage.setItem("message_count",0);
						return false;
					}else{
						for(var i=0;i<data.vo.length;i++){
							(data.vo)[i].isRead = true;
						}
						messageCount = data.vo.length;
					}
				}
				localStorage.setItem("messagelist",JSON.stringify(data));
				localStorage.setItem("message_count",messageCount);
				tourist.showMessageCount();
			}
		},
		error : function(e) {
			
		},
		complete : function() {
		}
	});
}