var urls = new Array("appinter/messagejsonp/listMessage.do?callback=?","appinter/messagejsonp/listContent.do?callback=?&messageId=");
$(function(){
	sd.ui.initFooter(5, 2);
	tourist.showMessageCount();
	sd.dialog.initDialog();
	initMessageShowPanel();
	//refreshLayout();
	var data = localStorage.getItem("messagelist");
	if(data!=null){
		createMessageList(JSON.parse(data));
	}
	
	
	$('.return').hide();
	$(".section").live("singleTap",function(){
		selectMessage($(this).attr("id").trim());
	});
	$(".btn-return").live("singleTap",function(){
		$("#messageContent").html("");
	});
	
	$('.section').live('swipeLeft',function(){
		if(!$(this).hasClass('now_open')){
			$(this).css({left:-60+'px'}).addClass('now_open');
		}
	});
	
	$('.section').live('swipeRight',function(){
		if($(this).hasClass('now_open')){
			$(this).css({left:0+'px'}).removeClass('now_open');
		}
	});
});

function refreshLayout() {
	var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height();
	var refreshDom = $('.ui-content').css("width", "100%").css("height", wrapperHeight);
	refreshDom.refresh({
		load : function(dir, type) {
			console.log("pull up load more ");
		}
	});
	$(refreshDom).css("height", "auto");
	$(refreshDom).css("overflow", "hidden");
};

/**
 * 
 */
Handlebars.registerHelper("genContent", function(value) {
	if(!value||value==null||value.length<1){
		return "欢迎使用智慧游客户端";
	}else{
		//解析出来img标签。
		var $dom = $(value);
		$imgs = $dom.find("img");
		var reg=new RegExp("/kindeditor/plugins/","gmi");
		$.each($imgs,function(index,item){
			var src = $(this).attr("src");
			var index = src.indexOf("/kindeditor/plugins/");
			src = baseUrl + src.substring(index+1,src.length).trim();
			console.info("src="+src);
			console.info("$(this)",$(this));
			console.info("index",index);
			$(this).attr("src",src);
		});
		return $dom.html();
	}
});
//handles list模块生成
function createMessageList(data){
	var source = $("#message-list-template").html();
    var template = Handlebars.compile(source);
	$(".ui-content").append(template(data));
	refreshLayout();
}

function initMessageShowPanel(){
	var refreshDom = $("#messageContent").css("height", $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height());
    refreshDom.refresh({
        iScrollOpts : {
            bounce : false
        }
    });
	$("#messageShowPanel").panel({
		contentWrap : "",
		swipeClose : true,
		dismissible : true,
		beforeopen : function() {
			$('.return').show();
			$(".return").live("singleTap",function(){
            	$('#messageShowPanel').panel('close');
            });
		},
		open : function() {
			refreshDom.refresh('this')._options.iScroll.refresh();
		},
		beforeclose : function() {
			$('.return').hide();
		}
	});
};

function selectMessage(messageId){
	$.ajaxJSONP({
        type: "GET",
        url: baseUrl+urls[1]+messageId,
        beforeSend: function(){
        	sd.loading.show();
        },
        success: function(data){
            if(data){
            	var messagelist = JSON.parse(localStorage.getItem("messagelist"));
            	for(var i=0;i<messagelist.vo.length;i++){
            		if(messageId==(messagelist.vo)[i].messageId){
            			if((messagelist.vo)[i].isRead){
							(messagelist.vo)[i].isRead = false;
			            	$("#"+messageId).children(".div_icon").children().hide();
			            	var num = parseInt(localStorage.getItem("message_count"))-1;
			            	localStorage.setItem("message_count",num);
			            	if(num>0){
			            		$(".message_number").text(num);
			            	}else{
			            		tourist.hideMessageCount();
			            	}
			            	break;
						}
            		}
            	}
            	localStorage.setItem("messagelist",JSON.stringify(messagelist));
            	sd.loading.hide();
            	createMessageDetails(data.vo.message);
            }
        },
        error: function(e){
            sd.dialog.showShort("加载数据失败，请检查网络连接是否正常！");
        	sd.loading.hide();
        },
        complete: function(){
        	sd.loading.hide();
        }
    });
};

function createMessageDetails (data){
	if(!data||data.length<1){
		if($(".message-list").eq(0).children("li").length<1  && $(".message-list").eq(0).children('img[class="nomoredatashow"]').length<1){
			$(".message-list").eq(0).append('<img class="nomoredatashow" id="data-list-1-no-data" src="../img/nomoredata.png" style="width:200px;height:100px;margin:0 auto;margin-top:20px;display:block;"/>');	
		}
	}else{
		//清除
		$("#data-list-1-no-data").remove();	
		var source = $("#message-details-template").html();
	    var template = Handlebars.compile(source);
		$("#messageContent").html(template(data));
		$('#messageShowPanel').panel('open', 'overlay', 'right');
	}
};