var urls = new Array("appinter/travelregionjsonp/selectscenicarea.do?callback=?", "appinter/travelregionjsonp/selectScenicareaAtlas.do?callback=?", 
"appinter/travelregionjsonp/listscenicspot.do?callback=?","/appinter/scenicareascorejsonp/saveScore.do?callback=?&userId=" + tourist.appuser.id,
"appinter/travelregionjsonp/selectScenicArea.do?callback=?",
"appinter/travelregionjsonp/selectScenicAreaPicZoomed.do?callback=?");

//定义一个全局定时器
var timer = null;
var maxLevel = 0;
var minLevel = 0;
//··后台传入来的原图数据
var origin = [];
//默认的偏移比例
var rateXY = 1;
//初始化基比数据
var initRate = 1;
//当前被基比数据
var nowRate = 1;
//提供切换路线图
var mapAndItineraryObj = {"itineraryAttach":null,"mapAttach":null};
var mapList = null;
var leftTop = [];
var rightBottom = [];
$(function() {
    initTabs();
    sd.ui.initFooter(5, 2);
    sd.dialog.initDialog();
    initHandlebarHelper();
    initSubmitScoreDialog();
    initRefreshLayout();
   	
    $(".btn-return").live("singleTap", function() {
        window.history.go(-1);
    });
    
    Handlebars.registerHelper("scenicAreaTicketStr", function(value) {
		try{
			if(typeof(this.scenicAreaTicket)=="number" || !isNaN(this.scenicAreaTicket)){//不是字符串的，判断是不是数字
				return new Handlebars.SafeString(this.scenicAreaTicket + "元");
			}
		}catch(e){
			return new Handlebars.SafeString(this.scenicAreaTicket);
		}
		
		return new Handlebars.SafeString(this.scenicAreaTicket);
    });
});

function initSubmitScoreDialog() {

    SELECTED_SCORE = 1;

    var html = '<div class="star-list" id="star-list"><span class="vote-star" qs=\"' + 1 + '\"><img src="../img/star-s.png" selectedUrl="../img/star-s.png" normalUrl="../img/star-c.png" class="star"/></span>';
    for (var i = 2; i <= 5; i++) {
        html += '<span class="vote-star" qs=\"' + i + '\"><img src="../img/star-c.png" selectedUrl="../img/star-s.png" normalUrl="../img/star-c.png" class="star"/></span>';
    }
    html += '</div>';

    SUMIT_SCORE_DIALOG = gmu.Dialog({
        width : 300,
        autoOpen : false,
        closeBtn : false,
        buttons : {
            '取消' : function() {
                this.close();
            },
            '确定' : function() {
                this.close();
                sd.loading.show();
                var scenicAreaInfo = JSON.parse(sessionStorage.getItem("scenicAreaInfo"));
                $.ajaxJSONP({
                    type : "GET",
                    url : baseUrl + urls[3] + "&scenicAreaId=" + scenicAreaInfo.scenicAreaid + "&score=" + SELECTED_SCORE,
                    beforeSend : function() {
                    },
                    success : function(data) {
                        if (data.vo && data.vo == 1)
                            sd.dialog.success("评分成功");
                        else
                            sd.dialog.success("提交评分失败，请不要重复提交");
                        sd.loading.hide();
                    },
                    error : function(e) {
                        sd.loading.hide();
                    },
                    complete : function() {
                        sd.loading.hide();
                    }
                });
            }
        },
        content : html
    });

    $("#star-list").parent().parent().addClass('selfDefinedCssStyleDialog');

    $(".vote-star").live("singleTap", function() {
        //1、获取当前星星的位置
        var $span = $(this);
        $thisImg = $($span.children("img").get(0));
        var spanArray = $("#star-list").children("span");
        var qscope = $span.attr("qs");
        var selectedIndex = parseInt(qscope);
        SELECTED_SCORE = selectedIndex;
        //2、从1开始，到当前星星的位置，添加上选择效果
        $.each(spanArray, function(index) {
            var $img = $($(this).children("img").get(0));
            index = index + 1;
            if (index <= selectedIndex) {
                $img.attr("src", $img.attr("selectedUrl"));
            } else {
                $img.attr("src", $img.attr("normalUrl"));
            }
        });
    });
}

function initHandlebarHelper() {
    // 注册一个生成图片src用的Helper
    Handlebars.registerHelper("genAttachImgSrc", function(value) {
        return tourist.genAttachImgUrl(value);
    });
}

function hideTabs(i) {
    $('#tabs1').tabs('this')._options.items[i].content.hide();
    $('#tabs1').find("li").eq(i).hide();
}

// tabs初始化
function initTabs() {
    var contentHeight = $(window).height() - $('.ui-toolbar-header').height() - $("#tabs1").find("li").height() - $('.ui-toolbar-footer').height() - 15;
    //不知道哪多的
    $("#content1").css("height", contentHeight);
    $("#content2").css("height", contentHeight);
    $("#content3").css("height", contentHeight);
    var activeItem = sessionStorage.getItem("returnFromSpotView") == null ? 0 : 2;
    sessionStorage.removeItem("returnFromSpotView");
    activeItem = sessionStorage.getItem("returnToMapView") == null ? activeItem : 1;
    sessionStorage.removeItem("returnToMapView");
    $('#tabs1').tabs({
    	active: activeItem,
        transition : "slide"
    });
    $('#tabs1').on('activate', function(e, to, from) {
    	if (to.index == 0 || to.index == 2){
        	$(".ui-refresh").eq(to.index == 2 ? 1 : to.index).refresh('this')._options.iScroll.refresh();
        }
    });
}

function refreshRefreshLayout(i) {
    $("#content" + i).find('.ui-refresh').refresh('this')._options.iScroll.refresh();
}

function initRefreshLayout() {
    var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height() - $("#tabs1").find("li").height() - $('.ui-toolbar-footer').height();
    $("#content1").find('.ui-refresh').css("width", "100%").css("height", wrapperHeight).refresh();
    var scenicAreaInfo = JSON.parse(sessionStorage.getItem("scenicAreaInfo"));
    $(".ui-toolbar-header-middle-box").html(subString(scenicAreaInfo.scenicAreaName, 14, true));
    var params = "&scenicAreaId=" + scenicAreaInfo.scenicAreaid;
    //content1 加载
    $.ajaxJSONP({
        type : "GET",
        url : baseUrl + urls[0] + params,
        beforeSend : function() {
            sd.loading.show();
        },
        success : function(data) {
            var source = $("#content1-template").html();
            var template = Handlebars.compile(source);
            var html = template(data);
            $("#content1").find('.ui-refresh').append(html);
            $("#phone_call").on("singleTap", function() {
                sd.native.Phone.call($(this).attr("phoneNumber"));
            });
            $("#map_navigation").on("singleTap", function() {
                sd.native.Map.show($(this).attr("longitude"), $(this).attr("latitude"), $(this).attr("address"));
            });
            refreshRefreshLayout(1);
            //如果初始显示的不是tab1，那么必须在渲染完refresh组件后，手动指定tab1中refresh-wrapper的高度，否则高度为0
            $("#content1").find('.ui-refresh-wrapper').css("height", wrapperHeight);
        },
        error : function(e) {
        	sd.loading.hide();
            sd.dialog.showShort("加载景区数据失败！");
        },
        complete : function() {
            $("#submit_score").on("singleTap", function() {
                SUMIT_SCORE_DIALOG.open();
            });
            sd.loading.hide();
        }
    });

    //content2 加载
    $.ajaxJSONP({
        type : "GET",
//      url : baseUrl + urls[1] + params,
        url : baseUrl + urls[4] + params,
        beforeSend : function() {
//			clearInterval(timer);
        },
        success : function(data) {
        	console.info("data:"+JSON.stringify(data))
            if (!(data.vo.mapAttach)) {//基本地图若没有则不显示
                hideTabs(1);
                origin = null;
                maxLevel = null;
	            minLevel = null;
           		mapAndItineraryObj.mapAttach = null;
                return;
            }else{//有地图则显示
            	/*
				//存储第一次接收到的数据，命名方式：景点+等级，网页session缓存
				var sessionName = scenicAreaInfo.scenicAreaid + "0";
	            sessionStorage.setItem(sessionName,JSON.stringify(data));*/
	            
	            var source = $("#spot-map-template").html();
	            var template = Handlebars.compile(source);
	            var html = template(data);
	            $("#content2").find('.ui-map').append(html);
	            $("#mapVisualDiv").css("height", wrapperHeight).css("width", $(window).width());
	           
	            /*var mapName = data.vo.mapAttach;
	            if(localStorage.getItem(mapName)!= null){
	            	$("#mapObj").attr("src",localStorage.getItem(mapName));
	            }*/
	            //初始化全局数据
	            origin = data.vo.spotlist;
	            maxLevel = data.vo.maxLevel;
	            minLevel = data.vo.minLevel;
	            if(data.vo.rightBottom!=undefined && data.vo.leftTop!=undefined){
		            rightBottom = data.vo.rightBottom;
		            leftTop = data.vo.leftTop;
	            }

	            initRate = data.vo.mapRate;//初始化图片比率，暂时没有用到
	            
				//提供切换导航图片是调用
           		mapAndItineraryObj.mapAttach = tourist.genAttachImgUrl(data.vo.mapAttach);
	            if(data.vo.itineraryAttach!=undefined){//存在导航图则显示按钮
					$(".showItineraryRate").show();
           			mapAndItineraryObj.itineraryAttach = tourist.genAttachImgUrl(data.vo.itineraryAttach);
	            }else{//不存在导航图则影藏按钮
					$(".showItineraryRate").hide();
           			mapAndItineraryObj.itineraryAttach = null;
	            }
	           
				//初始化控件  spot_detail_player.js
				initControl();
				//设置放大缩小按钮事件 spot_map_scale.js
	            refreshImgButton();
				initImgButtonClick();
				//设置mapContainer的宽高
			    sessionStorage.removeItem("itineraryFlag");
				var mapUrl = $("#mapObj").attr("src");
				setMapObj(mapUrl,false);//spot_map_settion.js获取和设置图片大小
				
            }
        },
        error : function(e) {
              sd.dialog.showShort("加载景区地图失败！");
        },
        complete : function() {
        }
    });

    //content3 加载
    $.ajaxJSONP({
        type : "GET",
        url : baseUrl + urls[2] + params,
        beforeSend : function() {
        },
        success : function(data) {
            if (data.vo.length == 0) {
                hideTabs(2);
                return;
            }
            var rows = Math.ceil(data.vo.length / 3);
            var boxhtml = $("#content3-box-template").html();
            while (rows--)
            $("#content3").find('.ui-refresh').append(boxhtml);
            for (var i = 0; i < data.vo.length; i++) {
                var item = $(".fluid_img_warp").eq(i);
                item.css("background-image", "url(" + tourist.genAttachImgUrl(data.vo[i].thumbnail) + ")");
                item.attr("id", data.vo[i].scenicSpotid);
                item.find(".img_desc_mark").css("display", "block");
                item.find(".desc").html(data.vo[i].scenicSpotName);
                item.on("singleTap", function() {
                    var scenicSpotInfo = {
                        scenicSpotName : $(this).find(".desc").html(),
                        scenicSpotid : $(this).attr("id")
                    };
                    sessionStorage.setItem("scenicSpotInfo", JSON.stringify(scenicSpotInfo));
                    window.location.href = "spot_view.html";
                });
                //item.find("img").attr("src",data.vo[i].thumbnail).css("width",100);
            }
           refreshRefreshLayout(3);
           $("#content3").find('.ui-refresh-wrapper').css("height", wrapperHeight);
        },
        error : function(e) {
            //sd.dialog.showShort("连接超时！");
        },
        complete : function() {
        }
    });
}

function subString(str, len, hasDot) 
{ 
    var newLength = 0; 
    var newStr = ""; 
    var chineseRegex = /[^\x00-\xff]/g; 
    var singleChar = ""; 
    if(str!=null){
    	var strLength = str.replace(chineseRegex,"**").length; 
	    if(strLength==(len+2)){
	    	return str;
	    }
	    for(var i = 0;i < strLength;i++) 
	    { 
	        singleChar = str.charAt(i).toString(); 
	        if(singleChar.match(chineseRegex) != null) 
	        { 
	            newLength += 2; 
	        }     
	        else 
	        { 
	            newLength++; 
	        } 
	        if(newLength > len) 
	        { 
	            break; 
	        } 
	        newStr += singleChar; 
	    } 
	     
	    if(hasDot && strLength > len) 
	    { 
	        newStr += ".."; 
	    } 
	    return newStr; 
    }else{
    	return str;
    }
}

