$(function() {
	sd.ui.initFooter(5, 2);
	sd.dialog.initDialog();
	tourist.showMessageCount();
	storage = window.localStorage;
	
	//storage.clear();
	
	getDownLoadList();//可下载列表
	
	getDownLoadedList();//已下载列表

	
	//可下载列表div
	var downloadedListWrap = document.getElementById("downloadedListWrap").parentNode;
	//已下载列表div
	var candownloadListWrap = document.getElementById("candownloadListWrap").parentNode;	
	
	if(candownloadListWrap&&downloadedListWrap){
		candownloadListWrap.style['display'] = 'block';
		candownloadListWrap.style['margin'] = '0px';
		candownloadListWrap.style['padding'] = '0px';
		
		downloadedListWrap.style['display'] = 'none';
		downloadedListWrap.style['margin'] = '0px';
		downloadedListWrap.style['padding'] = '0px';
				
	}
	
});

var index = 50;
var storage ;
var endTime ="";
var pageSize = "10";
var startTime="";
var init = true;
var me ;

var key = "DownLoadedList";
var hasDownloadTask = true;

//已下载列表
function getDownLoadedList() {
	for(var i=0;i<storage.length;i++){
	  //key(i)获得相应的键，再用getItem()方法获得对应的值
	  var key = storage.key(i) ;
	  
	  if(key.indexOf('_DownLoaded') != -1){
		  	var str = storage.getItem(storage.key(i));
		  	var  data = eval("(" + str + ")");
		  	addDownLoadedItem(data, i);
	   }
	 }

  	$('#downloadedListWrap').css('height', window.innerHeight - ($('header').height() || 42) - $(".downlloadheader").height() - $(".ui-toolbar-footer").height()).refresh({
		load : function(dir, type) {
			console.log("pull up load more ");
		}
	});	 
}

//未下载列表
function getDownLoadList() {
	
	// 获取未下载完成的 数据
	for(var i=0;i<storage.length;i++){
	  //key(i)获得相应的键，再用getItem()方法获得对应的值
	  var key = storage.key(i) ;
	  
	  if(key.indexOf('_DownLoading') != -1){
		  	var str = storage.getItem(storage.key(i));
		  	if(str){
			  	var  data = eval("(" + str + ")");
			  	addDownLoadItem(data[i], i);		  		
		  	}
	  	 }
	 }	
	
	
	//2、请求后台，获取当前地区特色的信息

	var url = baseUrl + "appinter/travelregionjsonp/listappdata.do?callback=?&pageSize="+pageSize+"&endTime="+endTime;
	
	$.ajaxJSONP({
		type : "GET",
		url : url,
		beforeSend : function() {
			if(init){
				sd.loading.show();
			}
		},
		success : function(data) {
			
			if (data && data.result == 1) {
				var obj = data.vo;
				for (var i = 0; i < obj.length; i++) {
					addDownLoadItem(obj[i], i);
				};
				
			}else{
				return false;
			}
		},
		error : function(e) {
			sd.loading.hide();
			sd.dialog.showShort("加载数据失败，请检查网络连接是否正常！");
			/*if(init){
				sd.loading.hide();
			}*/
			
		},
		complete : function() {
			sd.loading.hide();
			if(init){
				sd.loading.hide();
				// 保证只注册一次
			  	$('#candownloadListWrap').css('height', window.innerHeight - ($('.ui-toolbar-header').height() || 42) - $(".downlloadheader").height() - $(".ui-toolbar-footer").height()).refresh({
					load : function(dir, type) {
						me = this;
						console.log("pull up load more ");
						getDownLoadList();
						if(me){
							$('.ui-refresh').refresh('this').afterDataLoading(dir);
							me.afterDataLoading();    //数据加载完成后改变状态
						}
					}
				});
					
			}
			init = false;
			return false;
		}
	});

}

//更新下载进度
//progressNumId ;下载进度所在的div id
//progressId;下载的div进度条的div id
//progress;下载进度值
function updatePrggress(progressNumId, progressId, progress) {
	
	//下载列表div
	var candownloadList = document.getElementById('candownloadList');
	//下载列表-item div
	var item = document.getElementById('item_' + progressNumId);
	
	var downloading = item.dataset.downloading;//是否正在下载
	
	if(downloading&&downloading==='0'){
		return ;
	}
	
	//下载进度值div
	var pbn = document.getElementById(progressNumId);
	//下载的进度条div
	var pb = document.getElementById(progressId);
	var wrapper ;
	
	if(pb){
		//下载的进度条的外层包裹div
	   wrapper = pb.parentNode;
	}	
	
	//下载-item 的景点ID		
	var scenicAreaId = item.dataset.scenicareaid ;
	
	if (progress === '100%') {
	
		hasDownloadTask = false;
		
		pbn.innerText = "下载完成";

		if (candownloadList) {
			
			//candownloadList.removeChild(item);
			
			//隐藏进度条
			wrapper.style['display']='none';
			
			var item0 = wrapper.parentNode;
		  	if(item0){
		  		var img = item.getElementsByTagName('img')[0];
		  		if(!img){
		  			return  ;
		  		}
		  		if (img.src.indexOf('stop_download') != -1) {
					//切换成 下载图标
					img.src = "img/download.png";
					img.style['margin-top'] = '5px';
				} else {
					//切换成 停止下载图标
					img.src = "img/stop_download.png";
					img.style['margin-top'] = '9px';
				}
		  	}
			
			var data = {
				folder : scenicAreaId,
				scenicAreaName : item.dataset.scenicareaname
			};
			var str = JSON.stringify(data);
			var downloaded = storage.getItem(scenicAreaId+"_DownLoaded");
			if(downloaded){
				var downloadedList = document.getElementById('downloadedList');
				var item_ = document.getElementById("item_"+data.folder);
				if(item_){
					document.body.removeChild(item_);
				}
				storage.removeItem(scenicAreaId+"_DownLoaded");//清除下载
			}
			storage.setItem(scenicAreaId+"_DownLoaded",str);
			index++;
			addDownLoadedItem(data, index);
			storage.removeItem(scenicAreaId+"_DownLoading");//清除已下载
		} 
	} else {
		hasDownloadTask = true;

		var json = item.dataset.json;
			
		storage.setItem(scenicAreaId+"_DownLoading",json);//设置b为"isaac"
		
		pbn.innerText = "已下载" + progress;
 		
		 if(wrapper){
			 wrapper.style['display'] = 'block';
		 }
		
	}
	
	pb.style['width'] = progress;
}

//切换选项卡
function switchTab(type) {
	
	//已下载列表
	var downloadedListWrap = document.getElementById("downloadedListWrap").parentNode;
	//可下载列表
	var candownloadListWrap = document.getElementById("candownloadListWrap").parentNode;	
	
	var title1 = document.getElementById('title1');
	var title2 = document.getElementById('title2');
	
	if (type == 0) {
		
		candownloadListWrap.style['display'] = 'block';
		downloadedListWrap.style['display'] = 'none';
		
		title1.className = 'downloadselect';
		title2.className = '';
		
	} else {
		
		candownloadListWrap.style['display'] = 'none';
		downloadedListWrap.style['display'] = 'block';
		
		title1.className = '';
		title2.className = 'downloadselect';
		
	}
}

var i = 0 ;

//开始下载
/*
 * obj；下载列表item对象
 * 
 * 点击下载按钮开始下载文件
 * 
 * 如果下载按钮的图标为stop_download.png的话就下载文件，否则为取消下载并切换对应的下载图标
 * 
 * 下载{
 * 	调用	android端startDownLoad 方法开始下载文件，
 * 并传以下参数
 * @param url 下载URL
 * @param fileName 下载音频文件名称
 * @param pbid 下载时的展示的进度条div的id标识
 * @param pnumid 下载时的展示的数字进度值div的id标识
 * @param scenicareaid 下载的景点ID
 * 
 *  开始下载后android会回调updatePrggress方法更新对应的item进度条信息
 * }
 * 
 * 取消下载（调用cancelDownload并传 fileName 下载音频文件名称）
 * 
 */
function startDownload_(obj) {
	var img = obj.getElementsByTagName('img')[0];//下载按钮
	var url = obj.dataset.url;//下载URL
	var fileName = obj.dataset.dowmfilename;//下载文件名称
	
	var pbid = obj.dataset.pbar;//下载进度条div的id
	var pnumid = obj.dataset.pnum;//下载进度值div的id
	var pbn = document.getElementById(pnumid);//下载进度值div
    var scenicareaid = obj.dataset.scenicareaid;//景点ID
	
	if(pbn){
		pbn.innerText = "等待下载";
	}
	
	var pbw = document.getElementById("pbwrapper_" + pbid);//下载进度条div的父div
	if (pbw) {
		pbw.style['display'] = 'block';
	}
	i++;
	//console.log("i:"+i);
	if (img.src.indexOf('stop_download') != -1) {
		obj.dataset.downloading='0';
		//切换成 下载图标
		img.src = "img/download.png";
		img.style['margin-top'] = '5px';
		pbw.style['display'] = 'none';
		//console.log("stop img.src："+(img.src));
		var pb = document.getElementById(pbid);
		if(pb){
			pb.style['width'] = "0%";
		}
		window.JS_Download.cancelDownload(fileName);
		pbn.innerText = "";
	} else {
		//切换成 停止下载图标
		img.src = "img/stop_download.png";
		img.style['margin-top'] = '9px';
		pbw.style['display'] = 'block';
		obj.dataset.downloading='1';
		window.JS_Download.startDownLoad(url, fileName, pbid, pnumid,scenicareaid);
		//console.log("start img.src："+(img.src));
		
	}
	
}

//下载失败
/*
 * 下载失败回传progressNumId进度id，progressId进度条id,并切换为下载前的状态
 */
function downLoadError(progressNumId, progressId){
	
	var pbn = document.getElementById(progressNumId);
	var pb = document.getElementById(progressId);
	if(pbn){
		pbn.innerText = "";
	 	pb.style['width']='0%';
		var wrapper = pb.parentNode;
		if(wrapper){
		  wrapper.style['display'] = 'none';
		  var item = wrapper.parentNode;
		  	if(item){
		  		var img = item.getElementsByTagName('img')[0];
		  		if(!img){
		  			return  ;
		  		}
		  		if (img.src.indexOf('stop_download') != -1) {
					//切换成 下载图标
					img.src = "img/download.png";
					img.style['margin-top'] = '5px';
				} else {
					//切换成 停止下载图标
					img.src = "img/stop_download.png";
					img.style['margin-top'] = '9px';
				}
		  	}
		}
	}
	
}


//删除已下载文件
/*
 * 按已下载文件的路径调用android的deleteFile方法删除文件及item
 */
function remove(folder) {
	var downloadedList = document.getElementById('downloadedList');
	var item = document.getElementById('item_'+folder);
	downloadedList.removeChild(item);
	window.JS_Download.deleteFile(folder);
	storage.removeItem(folder+"_DownLoaded");//清除storage
}


var base_download = baseUrl+"appinter/travelregionjsonp/download.do?scenicAreaId=";

var downloadIndex = 0;
function addDownLoadItem(data, index) {
	
	index = downloadIndex++;
	
	if(!data){
		return ;
	}
	
	endTime = data.createtime;
	
	var candownloadList = document.getElementById('candownloadList');
	
	var n = data.dataSize/1024/1024;
	n = n.toFixed(2);

	var url = base_download + data.scenicAreaId;
	var txt = data.scenicAreaName + " （"+(n)+"M）";
	
	var div1 = document.createElement("div");
	div1.className = "item";
	div1.id = "item_progressNum_" + index;
	div1.dataset.cc = "1";
	div1.onclick = function() {
		console.log("**********************************************************");
		startDownload_(this);
		if(this.dataset.cc==='1'){
			this.dataset.cc='1';
			//startDownload_(this);	
		}
		this.dataset.cc='2';
	};
	
	//存储进度id
	div1.dataset.pnum = "progressNum_" + index;
	//存储进度条id
	div1.dataset.pbar = "progress_" + index;
	//存储下载地址
	div1.dataset.url = url;
	//存储下载文件名称
	div1.dataset.dowmfilename = data.scenicAreaId + ".zip";
	//存储景点id
	div1.dataset.scenicareaid = data.scenicAreaId;
	//存储景点名称
	div1.dataset.scenicareaname = txt;
	
	var str = JSON.stringify(data);
	
	div1.dataset.json = str;

	var div2 = document.createElement("div");
	div2.className = "item1";
	
	/**  下载名称  */
	var div3 = document.createElement("div");
	div3.className = "downloadName";
	div3.id = "downloadName_progressNum_" + index;
	div3.innerText = txt;

	var div4 = document.createElement("div");
	div4.className = "progressBtn";

	var img5 = document.createElement("img");
	img5.src = "img/download.png";

	var div6 = document.createElement("div");
	div6.className = "progressNum";
	div6.id = "progressNum_" + index;

	/**  下载条  */
	var div7 = document.createElement("div");
	div7.className = "ProgressBar";
	div7.id = "pbwrapper_progress_" + index;

	/**  下载条进度  */
	var div8 = document.createElement("div");
	div8.className = "progress";
	div8.id = "progress_" + index;

	div1.appendChild(div2);
	div2.appendChild(div3);
	div2.appendChild(div4);
	div4.appendChild(img5);
	div2.appendChild(div6);
	div1.appendChild(div7);
	div7.appendChild(div8);
	candownloadList.appendChild(div1);
}

var downloadedIndex = 0;
function addDownLoadedItem(data, index) {

	index = downloadedIndex++;

	var downloadedList = document.getElementById('downloadedList');

	var div1 = document.createElement("div");
	div1.className = "item";
	div1.id = "item_"+data.folder;

	var div2 = document.createElement("div");
	div2.className = "item1";

	var div3 = document.createElement("div");
	div3.className = "downloadName";
	div3.innerText = data.scenicAreaName;

	var div4 = document.createElement("div");
	div4.className = "bofang";
	div4.onclick = function() {
		
	};

	var img5 = document.createElement("img");
	img5.src = "img/pofang.png";

	var div6 = document.createElement("div");
	div6.className = "progressBtn stop";
	
	div6.dataset.folder = data.folder;
	div6.dataset.aa = '1';
	
	div6.onclick = function() {
		remove(this.dataset.folder);
		if(this.dataset.aa==='1'){
			this.dataset.aa = '1';
			//remove(this.dataset.folder);
		}
		this.dataset.aa = '2';
	};

	var img7 = document.createElement("img");
	img7.src = "img/stop_download.png";

	div1.appendChild(div2);
	div2.appendChild(div3);
	div2.appendChild(div4);
	//div4.appendChild(img5);
	div2.appendChild(div6);
	div6.appendChild(img7);
	
	downloadedList.appendChild(div1);
	
}
