$(function(){
	sd.ui.initFooter(5, 2);
	sd.dialog.initDialog();
	tourist.showMessageCount();
	
	if(localStorage.getItem("code")){
		$("#login_text").text(localStorage.getItem("name"));
		$("#login").hide();
		$("#logout").show();
	}
	
	refreshLayout();
	
	dialog_confirm = gmu.Dialog({
		buttons: {
			'确定': function(){
				this.close();
				sd.native.Upgrade.startDownload();
			},
			'取消': function(){
				this.close();
			}
		},
		title:'<span>' + '版本更新' + '</span>',
		content:'检测到新的应用版本，是否更新？',
		autoOpen: false,
	    closeBtn: false,
	    mask: false,
		height: 150,
	    width: 300
	});
	
	$('#cancel').live("click",function(){
		$('#login').trigger("click");
	});
	
	$('#qq').live("click",function(){
		qq.qqLogin();
	});
	
	$('#sina').live("click",function(){
		sina.onClick();
	});
	
	$('.logout').live("click",function(){
		var type = localStorage.getItem("type");
		if(type=="qq"){
			qq.qqLogout();
		}else{
			if(type=="sina"){
				sina.onClick();
			}else{
				
			}
		}
	});
	
	var isShow = false;
	
	$('#login').popover({
		container  : navi_container,
		show:function(e){
			isShow = true;
			setTimeout(function(){isShow=false;},1000);
		},
		beforeshow:function(e){
			if(isShow){
				e.preventDefault();
			}
		},
		hide:function(e){
			isShow = true;
			setTimeout(function(){isShow=false;},1000);
		},
		beforehide:function(e){
			if(isShow){
				e.preventDefault();
			}
		}
	});
    
    /*$('#feedback').live("singleTap", function(){
        window.location.href = "feed_back.html";
    });
    
    $('#about').live("singleTap", function(){
        window.location.href = "about.html";
    });
    
    $('#updata').live("singleTap", function(){
        sd.native.Upgrade.isUpgradeAvailable("checkUpgradeCallback");
    });*/
    
    $("#share").live("singleTap",function(){
    });
    
    
    $(".travel_nanjing").live("singleTap", function(){
    	sessionStorage.setItem("dataType", $(this).attr("dataType"));
    	sessionStorage.setItem("dataTitle", $(this).attr("dataTitle"));
    	window.location.href = "travel_nanjing.html";
    });
});

function refreshLayout() {
	var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height();
	var refreshDom = $('.section').css("width", "100%").css("height", wrapperHeight);
	refreshDom.refresh({iScrollOpts : {
			bounce : false
		}});
	$(refreshDom).css("height", "auto");
	$(refreshDom).css("overflow", "hidden");
};

function checkUpgradeCallback(data) {
	if (data) {
		dialog_confirm.open();
	} else {
		sd.dialog.showShort("您目前使用的已经是最新版本了！");
	}
}

$(function() {
    $("#submit_feedback").on("singleTap", function() {
        var msg = {};
        msg.feedback = $("#feedback_txt").val();
        msg.userId = dragontang.appuser.id;

        if (!msg.feedback) {
            sd.dialog.showShort("请输入反馈内容");
            return;
        }

        if (msg.feedback.length < 15) {
            sd.dialog.showShort("反馈内容不得少于十五字");
            return;
        }

        var feedbackUrl = baseUrl + "/appinter/feedbackjsonp/savefeedback.do?callback=?";
        var fullUrl = feedbackUrl + "&userid=" + msg.userId + "&feedbackcontent=" + msg.feedback;
        fullUrl = decodeURIComponent(fullUrl, true);
		fullUrl = encodeURI(encodeURI(fullUrl));
        $.ajaxJSONP({
            type : "GET",
            url : fullUrl,
            beforeSend : function() {
                sd.loading.show();
            },
            success : function(data) {
            	console.info(data);
                sd.loading.hide();
                sd.dialog.showShort("提交成功");

                setTimeout(function() {
                    $(".btn-back").trigger("touchend");
                }, 1100);
            },
            error : function(e) {
                sd.loading.hide();
                sd.dialog.showShort("连接超时！请检查网络后重试！");
            },
            complete : function() {
                sd.loading.hide();
            }
        });
    });
});