$(function(){
	sd.ui.initFooter(5, 2);
	sd.dialog.initDialog();
	
	refreshLayout();
	
	$(".return").live("singleTap",function(){
    	window.history.go(-1);
    });
	
});

function refreshLayout() {
	var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height();
	var refreshDom = $('.section').css("width", "100%").css("height", wrapperHeight);
	refreshDom.refresh({iScrollOpts : {
			bounce : false
		}});
	$(refreshDom).css("height", "auto");
	$(refreshDom).css("overflow", "hidden");
};

$(function() {
    $("#submit_feedback").on("singleTap", function() {
        var msg = {};
        msg.feedback = $("#feedback_txt").val();
        msg.userId = tourist.appuser.id;

        if (!msg.feedback) {
            sd.dialog.showShort("请输入反馈内容");
            return;
        }

        if (msg.feedback.length < 15) {
            sd.dialog.showShort("反馈内容不得少于十五字");
            return;
        }

        var feedbackUrl = baseUrl + "appinter/feedbackjsonp/savefeedback.do?callback=?";
        var fullUrl = feedbackUrl+"&feedbackcontent=" + msg.feedback;
        fullUrl = decodeURIComponent(fullUrl, true);
		fullUrl = encodeURI(encodeURI(fullUrl));
        $.ajaxJSONP({
            type : "GET",
            url : fullUrl,
            beforeSend : function() {
                sd.loading.show();
            },
            success : function(data) {
            	console.info(data);
                sd.loading.hide();
                sd.dialog.showShort("提交成功");

                setTimeout(function() {
                    $(".btn-back").trigger("touchend");
                }, 1100);
            },
            error : function(e) {
                sd.loading.hide();
                sd.dialog.showShort("连接超时！请检查网络后重试！");
            },
            complete : function() {
                sd.loading.hide();
            }
        });
    });
});