$(function(){
	sd.ui.initFooter(5, 2);
	sd.dialog.initDialog();
	
	$(".return").live("singleTap", function(){
		//window.history.back();return;
		window.location.href="more.html";
	});
	
	refreshLayout();
	
	var dataType = sessionStorage.getItem("dataType");
	var dataTitle = sessionStorage.getItem("dataTitle");
	if (dataType != null)
		loadData(dataType);
	if (dataTitle != null)
		$("#character_title").html(dataTitle);
		
	$(".download_title").live("touchstart", function(){
		if ($(this).attr("downloadurl") != "")
			window.link.href($(this).attr("downloadurl"));
		else
			sd.dialog.showShort("无效地址，下载失败");
	});
	
	$("#app_logo").live("touchstart", function(){
		if ($(this).parent().next().children().attr("downloadurl") != "")
			//window.location.href = $(this).parent().next().children().attr("downloadurl");
			window.link.href($(this).parent().next().children().attr("downloadurl"));
		else
			sd.dialog.showShort("无效地址，下载失败");
	});
});

function loadData(dataType) {
	$.ajaxJSONP({
        type : "GET",
        url : baseUrl + "/appinter/travelinfojsonp/selectTravelInfo.do?callback=?&code=" + dataType,
        beforeSend : function() {
            //sd.loading.show();
        },
        success : function(data) {
            //sd.loading.hide();
            if (data.vo != null) {
            	switch(dataType) {
            		case "1" : $("#app_logo").attr("src",  "img/icon_app_01.png");
            			break;
            		case "2" : $("#app_logo").attr("src",  "img/icon_app_02.png");
            			break;
            		case "3" : $("#app_logo").attr("src",  "img/icon_app_03.png");
            			break;
            	}
            	$(".app_content").html(data.vo.content);
            	$(".download_title").attr("downloadurl", data.vo.link);
            }
        },
        error : function(e) {
            //sd.loading.hide();
            $(".section").hide();
            sd.dialog.showShort("加载数据失败，请检查网络连接是否正常！");
        },
        complete : function() {
            //sd.loading.hide();
        }
    });
}

function refreshLayout() {
	var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height();
	var refreshDom = $('.section').css("width", "100%").css("height", wrapperHeight);
	refreshDom.refresh({iScrollOpts : {
			bounce : false
		}});
	$(refreshDom).css("height", "auto");
	$(refreshDom).css("overflow", "hidden");
};
