function refreshImgButton(){
	if(maxLevel == 0){
		$(".img_up").addClass("imgOpacity");
	}
	if(minLevel == 0){
		$(".img_down").addClass("imgOpacity");
	}
}
//更新图片数据，可以跟refreshNewMap方法整合
function refreshMap(level){
    var scenicAreaInfo = JSON.parse(sessionStorage.getItem("scenicAreaInfo"));
    var params = "&scenicAreaId=" + scenicAreaInfo.scenicAreaid+"&level="+level;
	$.ajaxJSONP({
        type : "GET",
        url : baseUrl + urls[5] + params,
        beforeSend : function() {
//      	clearInterval(timer);
            sd.loading.show("正在搬运景区数据  请稍后......");
//      	console.info('params:'+params)
        },
        success : function(data) {
            //判断没有图片就不显示tab
            if (!(data.vo.mapAttach)) {
                hideTabs(1);
                origin = null;
                maxLevel = null;
	            minLevel = null;
	            mapAndItineraryObj.mapAttach = null;
                return;
           }else{//有图片就进行赋值操作
				//存储第一次接收到的数据，命名方式：景点+等级，网页session缓存
				var sessionName = scenicAreaInfo.scenicAreaid + level;
	            sessionStorage.setItem(sessionName,JSON.stringify(data));
	            console.info("data:"+JSON.stringify(data));
	            origin = data.vo.spotlist;
	            //获取偏移比例
	            nowRate = data.vo.mapRate;
	            rateXY = nowRate/initRate;
	            
//         		mapAndItineraryObj.mapAttach = tourist.genAttachImgUrl(data.vo.mapAttach);
           		mapAndItineraryObj.mapAttach = data.vo.mapAttach;
           		if(data.vo.itineraryAttach!=undefined){//存在导航图则显示按钮
					$(".showItineraryRate").show();
//         			mapAndItineraryObj.itineraryAttach = tourist.genAttachImgUrl(data.vo.itineraryAttach);
           			mapAndItineraryObj.itineraryAttach = data.vo.itineraryAttach;
	            }else{//不存在导航图则影藏按钮
					$(".showItineraryRate").hide();
           			mapAndItineraryObj.itineraryAttach = null;
	            }
	            var imgUrl = null;
			    var flag = sessionStorage.getItem("itineraryFlag");
			    if(flag == null){
//			    	imgUrl = tourist.genAttachImgUrl(data.vo.mapAttach);
			    	imgUrl = data.vo.mapAttach;
			    }else{
//			    	imgUrl = tourist.genAttachImgUrl(data.vo.itineraryAttach);
			    	imgUrl = data.vo.itineraryAttach;
				}
			    
				console.info("mapAttach:"+data.vo.mapAttach);
				console.info("itineraryAttach:"+data.vo.itineraryAttach);

				$("#mapObj").attr("src" ,imgUrl);
	            setMapObj(imgUrl,true);//spot_map_settion.js
	            
				
           }
        },
        error : function(e) {
        		sd.loading.hide();
              	sd.dialog.showShort("加载景区地图失败！");
        },
		complete :function(){
            $("#mapContainer").css({"left":0,"top":0});
			initMap();//初始化设置图片与定位  spot_position.js
        }
    });
}

/**
 * 有网页缓存的session数据则进行数据操作
 * @param {Object} data json数据
 */
function setObjFromSession(data){
	origin = data.vo.spotlist;
    //获取偏移比例
    nowRate = data.vo.mapRate;
    rateXY = nowRate/initRate;
    
    //以参数存储图片数据
//  setMapAttach(data.vo.mapAttach,data.vo.itineraryAttach);

//	mapAndItineraryObj.mapAttach = tourist.genAttachImgUrl(data.vo.mapAttach);
	mapAndItineraryObj.mapAttach = data.vo.mapAttach;
	if(data.vo.itineraryAttach!=undefined){//存在导航图则显示按钮
		$(".showItineraryRate").show();
//		mapAndItineraryObj.itineraryAttach = tourist.genAttachImgUrl(data.vo.itineraryAttach);
		mapAndItineraryObj.itineraryAttach = data.vo.itineraryAttach;
    }else{//不存在导航图则影藏按钮
		$(".showItineraryRate").hide();
		mapAndItineraryObj.itineraryAttach = null;
    }
    var imgUrl = null;
    var flag = sessionStorage.getItem("itineraryFlag");
    if(flag == null){
//  	imgUrl = tourist.genAttachImgUrl(data.vo.mapAttach);
    	imgUrl = data.vo.mapAttach;
    }else{
//  	imgUrl = tourist.genAttachImgUrl(data.vo.itineraryAttach);
    	imgUrl = data.vo.itineraryAttach;
	}

	$("#mapObj").attr("src" ,imgUrl);
    setMapObj(imgUrl,true);//spot_map_settion.js
}

/**
 * 判断是否已在景点的缓存的数据，有则缓存加载，没则远程加载并保存入缓存中
 * @param {Object} nowLevel 当前图片等级
 */
function refreshNewMap(nowLevel){
	$("#spotPosition").css("display","none");
	$("#playBg").css("display","none");
	
	var scenicAreaInfo = JSON.parse(sessionStorage.getItem("scenicAreaInfo"));
	//判断是否已有存储数据，提取方式：景点+等级，网页session缓存
	var sessionName = scenicAreaInfo.scenicAreaid + nowLevel;
	
	var data = JSON.parse(sessionStorage.getItem(sessionName));
	if(data != null){
        sd.loading.show("正在搬运景区数据  请稍后......");
		setObjFromSession(data);
	}else{
		refreshMap(nowLevel);
	}
	
}


/**
 * 放大缩小事件
 * 图片背景虚化
 */
function initImgButtonClick(){
	$(".img_up").on("touchstart",function(){
		var nowLevel = $(".imgLevel").attr("level");
		if( nowLevel < maxLevel && nowLevel >= minLevel){
			setLevel(1);
			if($(".imgLevel").attr("level") == maxLevel){
				$(this).addClass("imgOpacity")
				.siblings("img").removeClass("imgOpacity");
			}else{
				$(this).removeClass("imgOpacity")
				.siblings("img").removeClass("imgOpacity");
			}
			var refreshLevel = $(".imgLevel").attr("level");
			//刷新放大或缩小页面
			refreshNewMap(refreshLevel);
		}else{
			sd.dialog.showShort("已最大化")
		}
	})
	$(".img_down").on("touchstart",function(){
		var nowLevel = $(".imgLevel").attr("level");
		if(nowLevel <= maxLevel && nowLevel> minLevel){
			setLevel(-1);
			if($(".imgLevel").attr("level") == minLevel){
				$(this).addClass("imgOpacity")
				.siblings("img").removeClass("imgOpacity");
			}else{
				$(this).removeClass("imgOpacity")
				.siblings("img").removeClass("imgOpacity");
			}
			var refreshLevel = $(".imgLevel").attr("level");
			//刷新放大或缩小页面
			refreshNewMap(refreshLevel);
		}else{
			sd.dialog.showShort("已最小化")
		}
	})
}