var urls = new Array("appinter/travelregionjsonp/selectscenicspot.do?callback=?");
var scenicAreaInfo;
var scenicSpotInfo;
var isComplete = true;
$(function() {
	sd.dialog.initDialog();
    sd.ui.initFooter(5, 2);
    initRefreshLayout();
    scenicAreaInfo = JSON.parse(sessionStorage.getItem("scenicAreaInfo"));
    scenicSpotInfo = JSON.parse(sessionStorage.getItem("scenicSpotInfo"));
    sessionStorage.setItem("returnFromSpotView", true);
    
    $.ajaxJSONP({
        type : "GET",
        url : baseUrl + urls[0] + "&scenicspotId=" + scenicSpotInfo.scenicSpotid,
        beforeSend : function() {
            sd.loading.show();
        },
        success : function(data) {
            $(".view_img_wrap").css("background-image","url(" + tourist.genAttachImgUrl(data.vo.defaultPicture) + ")");
            $("#view_spot_name").html(scenicAreaInfo.scenicAreaName);
            $("#spot_view_name").html(scenicSpotInfo.scenicSpotName);
            $(".spot_view_desc_warp").html(data.vo.scenicSpotSummary);
            initNativePlayer(data.vo.scenicSpotAudio);
    
        },
        error : function(e) {
            sd.loading.hide();
            sd.dialog.showShort("加载景区信息失败！");
        },
        complete : function() {
            sd.loading.hide();
        }
    });
});

function refreshRefreshLayout() {
    $('.ui-refresh').refresh('this')._options.iScroll.refresh();
}

function initRefreshLayout() {
    var wrapperHeight = $(window).height() - $('.ui-toolbar-footer').height();
    var refreshDom = $('.ui-refresh').css("width", "100%").css("height", wrapperHeight);
    refreshDom.refresh();
    $(refreshDom).css("height", "auto");
    $(refreshDom).css("overflow", "hidden");
}

function initNativePlayer(scenicSpotAudio) {
	$("#playerButton").attr("src", "img/button_play.png");
	
	tourist.jsplayer.init({
    	scenicAreaId : scenicAreaInfo.scenicAreaid,
		scenicSpotId : scenicSpotInfo.scenicSpotid,
		downloadUrl : baseUrl + "/appinter/scenicspotjsop/downloadScenicSpot.do?AttachId=" + scenicSpotAudio,
		onStartPlay : function(){
			$("#playerButton").attr("src", "img/button_pause.png");
		},
		onReplay : function(){
			$("#playerButton").attr("src", "img/button_pause.png");
		},
		onPause : function(){
			$("#playerButton").attr("src", "img/button_play.png");
		},
		onUpdateProgress : function(){
			$(".progess").css("width", (tourist.jsplayer.percent * 100) + "%");
    		$(".cursor").css("left", (tourist.jsplayer.percent * 100) + "%");	
		},
		onComplete : function(){
			$("#playerButton").attr("src", "img/button_play.png");
		},
		onloading : function() {
			$("#playerButton").attr("src", "img/audio_loading.gif");
		},
		onLoadError : function() {
			$("#playerButton").attr("src", "img/button_play.png");
			sd.dialog.showShort("播放失败");
		},
		onLoadComplete : function() {
			$("#playerButton").attr("src", "img/button_pause.png");
		}
    });

	$("#playerButton").on("singleTap", function() {
		tourist.jsplayer.play();
    });
    refreshRefreshLayout();
}

function updateProgressBar(){
	if (tourist.player.lastPosition >= window.ScenicAudio.currentPosition()) {
		tourist.player.lastPosition = 0;
		clearInterval(tourist.player.interval);
		$("#playerButton").attr("src", "img/button_play.png");
		return;
	}

	tourist.player.percent = window.ScenicAudio.currentPosition() / tourist.player.duration;
	$(".progess").css("width", (tourist.player.percent * 100) + "%");
    $(".cursor").css("left", (tourist.player.percent * 100) + "%");
    tourist.player.lastPosition = window.ScenicAudio.currentPosition();
    console.log(tourist.player.lastPosition);
}

